diff --git a/src/main/java/net/minecraft/core/net/entity/NetEntityHandler.java b/src/main/java/net/minecraft/core/net/entity/NetEntityHandler.java
index 598bcf8ea..d087fd79f 100644
--- a/src/main/java/net/minecraft/core/net/entity/NetEntityHandler.java
+++ b/src/main/java/net/minecraft/core/net/entity/NetEntityHandler.java
@@ -1,22 +1,22 @@
 package net.minecraft.core.net.entity;
 
-import net.minecraft.core.net.entity.entries.AnimalNetEntry;
-import net.minecraft.core.net.entity.entries.ArrowNetEntry;
-import net.minecraft.core.net.entity.entries.BoatNetEntry;
-import net.minecraft.core.net.entity.entries.BobberNetEntry;
-import net.minecraft.core.net.entity.entries.CannonballEntry;
-import net.minecraft.core.net.entity.entries.EggNetEntry;
-import net.minecraft.core.net.entity.entries.FallingSandNetEntry;
-import net.minecraft.core.net.entity.entries.FireballNetEntry;
-import net.minecraft.core.net.entity.entries.FireflyNetEntry;
-import net.minecraft.core.net.entity.entries.ItemNetEntry;
-import net.minecraft.core.net.entity.entries.MinecartNetEntry;
-import net.minecraft.core.net.entity.entries.PaintingNetEntry;
-import net.minecraft.core.net.entity.entries.PebbleEntry;
-import net.minecraft.core.net.entity.entries.PlayerMPNetEntry;
-import net.minecraft.core.net.entity.entries.SnowballNetEntry;
-import net.minecraft.core.net.entity.entries.SquidNetEntry;
-import net.minecraft.core.net.entity.entries.TNTNetEntry;
+import net.minecraft.core.net.entity.entries.NetEntryAnimal;
+import net.minecraft.core.net.entity.entries.NetEntryArrow;
+import net.minecraft.core.net.entity.entries.NetEntryBoat;
+import net.minecraft.core.net.entity.entries.NetEntryBobber;
+import net.minecraft.core.net.entity.entries.NetEntryCannonball;
+import net.minecraft.core.net.entity.entries.NetEntryEgg;
+import net.minecraft.core.net.entity.entries.NetEntryFallingBlock;
+import net.minecraft.core.net.entity.entries.NetEntryFireball;
+import net.minecraft.core.net.entity.entries.NetEntryFirefly;
+import net.minecraft.core.net.entity.entries.NetEntryItem;
+import net.minecraft.core.net.entity.entries.NetEntryMinecart;
+import net.minecraft.core.net.entity.entries.NetEntryPainting;
+import net.minecraft.core.net.entity.entries.NetEntryPebble;
+import net.minecraft.core.net.entity.entries.NetEntryPlayerServer;
+import net.minecraft.core.net.entity.entries.NetEntrySnowball;
+import net.minecraft.core.net.entity.entries.NetEntrySquid;
+import net.minecraft.core.net.entity.entries.NetEntryPrimedTNT;
 import net.minecraft.core.net.packet.Packet;
 import net.minecraft.server.entity.EntityTrackerEntry;
 import org.jetbrains.annotations.NotNull;
@@ -126,26 +126,26 @@ public class NetEntityHandler {
     }
 
     static {
-        registerNetworkEntry(new AnimalNetEntry<>());
-        registerNetworkEntry(new SquidNetEntry());
-        registerNetworkEntry(new FireflyNetEntry());
-        registerNetworkEntry(new ItemNetEntry());
-        registerNetworkEntry(new PaintingNetEntry());
-        registerNetworkEntry(new PlayerMPNetEntry());
-
-        registerNetworkEntry(new ArrowNetEntry(), 1);
-        registerNetworkEntry(new CannonballEntry(), 2);
-        registerNetworkEntry(new EggNetEntry(), 3);
-        registerNetworkEntry(new FireballNetEntry(), 4);
-        registerNetworkEntry(new PebbleEntry(), 5);
-        registerNetworkEntry(new SnowballNetEntry(), 6);
-
-        registerNetworkEntry(new BoatNetEntry(), 10);
-        registerNetworkEntry(new MinecartNetEntry(), 11);
-
-        registerNetworkEntry(new FallingSandNetEntry(), 20);
-        registerNetworkEntry(new TNTNetEntry(), 21);
-
-        registerNetworkEntry(new BobberNetEntry(), 30);
+        registerNetworkEntry(new NetEntryAnimal<>());
+        registerNetworkEntry(new NetEntrySquid());
+        registerNetworkEntry(new NetEntryFirefly());
+        registerNetworkEntry(new NetEntryItem());
+        registerNetworkEntry(new NetEntryPainting());
+        registerNetworkEntry(new NetEntryPlayerServer());
+
+        registerNetworkEntry(new NetEntryArrow(), 1);
+        registerNetworkEntry(new NetEntryCannonball(), 2);
+        registerNetworkEntry(new NetEntryEgg(), 3);
+        registerNetworkEntry(new NetEntryFireball(), 4);
+        registerNetworkEntry(new NetEntryPebble(), 5);
+        registerNetworkEntry(new NetEntrySnowball(), 6);
+
+        registerNetworkEntry(new NetEntryBoat(), 10);
+        registerNetworkEntry(new NetEntryMinecart(), 11);
+
+        registerNetworkEntry(new NetEntryFallingBlock(), 20);
+        registerNetworkEntry(new NetEntryPrimedTNT(), 21);
+
+        registerNetworkEntry(new NetEntryBobber(), 30);
     }
 }
diff --git a/src/main/java/net/minecraft/core/net/entity/entries/AnimalNetEntry.java b/src/main/java/net/minecraft/core/net/entity/entries/NetEntryAnimal.java
similarity index 94%
rename from src/main/java/net/minecraft/core/net/entity/entries/AnimalNetEntry.java
rename to src/main/java/net/minecraft/core/net/entity/entries/NetEntryAnimal.java
index 93dc18279..06ec1769f 100644
--- a/src/main/java/net/minecraft/core/net/entity/entries/AnimalNetEntry.java
+++ b/src/main/java/net/minecraft/core/net/entity/entries/NetEntryAnimal.java
@@ -10,7 +10,7 @@ import net.minecraft.server.entity.EntityTracker;
 import net.minecraft.server.entity.EntityTrackerEntry;
 import org.jetbrains.annotations.NotNull;
 
-public class AnimalNetEntry<T extends Creature> implements IPacketEntry<T>, ITrackedEntry<T> {
+public class NetEntryAnimal<T extends Creature> implements IPacketEntry<T>, ITrackedEntry<T> {
     @Override
     public @NotNull Class<T> getAppliedClass() {
         return (Class<T>) Creature.class;
diff --git a/src/main/java/net/minecraft/core/net/entity/entries/ArrowNetEntry.java b/src/main/java/net/minecraft/core/net/entity/entries/NetEntryArrow.java
similarity index 67%
rename from src/main/java/net/minecraft/core/net/entity/entries/ArrowNetEntry.java
rename to src/main/java/net/minecraft/core/net/entity/entries/NetEntryArrow.java
index 4ca4c183e..3cc67a47d 100644
--- a/src/main/java/net/minecraft/core/net/entity/entries/ArrowNetEntry.java
+++ b/src/main/java/net/minecraft/core/net/entity/entries/NetEntryArrow.java
@@ -2,9 +2,9 @@ package net.minecraft.core.net.entity.entries;
 
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.entity.Mob;
-import net.minecraft.core.entity.projectile.ArrowProjectile;
-import net.minecraft.core.entity.projectile.GoldenArrowProjectile;
-import net.minecraft.core.entity.projectile.PurpleArrowProjectile;
+import net.minecraft.core.entity.projectile.ProjectileArrow;
+import net.minecraft.core.entity.projectile.ProjectileArrowGolden;
+import net.minecraft.core.entity.projectile.ProjectileArrowPurple;
 import net.minecraft.core.net.entity.ITrackedEntry;
 import net.minecraft.core.net.entity.IVehicleEntry;
 import net.minecraft.core.net.packet.AddEntityPacket;
@@ -13,10 +13,10 @@ import net.minecraft.server.entity.EntityTracker;
 import net.minecraft.server.entity.EntityTrackerEntry;
 import org.jetbrains.annotations.NotNull;
 
-public class ArrowNetEntry implements IVehicleEntry<ArrowProjectile>, ITrackedEntry<ArrowProjectile> {
+public class NetEntryArrow implements IVehicleEntry<ProjectileArrow>, ITrackedEntry<ProjectileArrow> {
     @Override
-    public @NotNull Class<ArrowProjectile> getAppliedClass() {
-        return ArrowProjectile.class;
+    public @NotNull Class<ProjectileArrow> getAppliedClass() {
+        return ProjectileArrow.class;
     }
 
     @Override
@@ -35,23 +35,23 @@ public class ArrowNetEntry implements IVehicleEntry<ArrowProjectile>, ITrackedEn
     }
 
     @Override
-    public void onEntityTracked(EntityTracker tracker, EntityTrackerEntry trackerEntry, ArrowProjectile trackedObject) {
+    public void onEntityTracked(EntityTracker tracker, EntityTrackerEntry trackerEntry, ProjectileArrow trackedObject) {
 
     }
 
     @Override
     public Entity getEntity(World world, double x, double y, double z, int metadata, boolean hasVelocity, double xd, double yd, double zd, Entity owner) {
         if (metadata == 2) {
-            return new GoldenArrowProjectile(world, x, y, z);
+            return new ProjectileArrowGolden(world, x, y, z);
         } else if (metadata == 1) {
-            return new PurpleArrowProjectile(world, x, y, z);
+            return new ProjectileArrowPurple(world, x, y, z);
         } else {
-            return new ArrowProjectile(world, x, y, z, metadata);
+            return new ProjectileArrow(world, x, y, z, metadata);
         }
     }
 
     @Override
-    public AddEntityPacket getSpawnPacket(EntityTrackerEntry tracker, ArrowProjectile trackedObject) {
+    public AddEntityPacket getSpawnPacket(EntityTrackerEntry tracker, ProjectileArrow trackedObject) {
         Mob entityliving = trackedObject.owner;
         return new AddEntityPacket(trackedObject,
             trackedObject.getArrowType(), entityliving == null ? -1 : entityliving.id,
diff --git a/src/main/java/net/minecraft/core/net/entity/entries/BoatNetEntry.java b/src/main/java/net/minecraft/core/net/entity/entries/NetEntryBoat.java
similarity index 95%
rename from src/main/java/net/minecraft/core/net/entity/entries/BoatNetEntry.java
rename to src/main/java/net/minecraft/core/net/entity/entries/NetEntryBoat.java
index 2adf2535c..7ca1d23a1 100644
--- a/src/main/java/net/minecraft/core/net/entity/entries/BoatNetEntry.java
+++ b/src/main/java/net/minecraft/core/net/entity/entries/NetEntryBoat.java
@@ -10,7 +10,7 @@ import net.minecraft.server.entity.EntityTracker;
 import net.minecraft.server.entity.EntityTrackerEntry;
 import org.jetbrains.annotations.NotNull;
 
-public class BoatNetEntry implements IVehicleEntry<BoatEntity>, ITrackedEntry<BoatEntity> {
+public class NetEntryBoat implements IVehicleEntry<BoatEntity>, ITrackedEntry<BoatEntity> {
     @Override
     public @NotNull Class<BoatEntity> getAppliedClass() {
         return BoatEntity.class;
diff --git a/src/main/java/net/minecraft/core/net/entity/entries/BobberNetEntry.java b/src/main/java/net/minecraft/core/net/entity/entries/NetEntryBobber.java
similarity index 75%
rename from src/main/java/net/minecraft/core/net/entity/entries/BobberNetEntry.java
rename to src/main/java/net/minecraft/core/net/entity/entries/NetEntryBobber.java
index 51ba03a60..753663735 100644
--- a/src/main/java/net/minecraft/core/net/entity/entries/BobberNetEntry.java
+++ b/src/main/java/net/minecraft/core/net/entity/entries/NetEntryBobber.java
@@ -1,7 +1,7 @@
 package net.minecraft.core.net.entity.entries;
 
 import net.minecraft.core.entity.Entity;
-import net.minecraft.core.entity.FishingBobberEntity;
+import net.minecraft.core.entity.EntityFishingBobber;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.net.entity.ITrackedEntry;
 import net.minecraft.core.net.entity.IVehicleEntry;
@@ -11,10 +11,10 @@ import net.minecraft.server.entity.EntityTracker;
 import net.minecraft.server.entity.EntityTrackerEntry;
 import org.jetbrains.annotations.NotNull;
 
-public class BobberNetEntry implements IVehicleEntry<FishingBobberEntity>, ITrackedEntry<FishingBobberEntity> {
+public class NetEntryBobber implements IVehicleEntry<EntityFishingBobber>, ITrackedEntry<EntityFishingBobber> {
     @Override
-    public @NotNull Class<FishingBobberEntity> getAppliedClass() {
-        return FishingBobberEntity.class;
+    public @NotNull Class<EntityFishingBobber> getAppliedClass() {
+        return EntityFishingBobber.class;
     }
 
     @Override
@@ -33,13 +33,13 @@ public class BobberNetEntry implements IVehicleEntry<FishingBobberEntity>, ITrac
     }
 
     @Override
-    public void onEntityTracked(EntityTracker tracker, EntityTrackerEntry trackerEntry, FishingBobberEntity trackedObject) {
+    public void onEntityTracked(EntityTracker tracker, EntityTrackerEntry trackerEntry, EntityFishingBobber trackedObject) {
 
     }
 
     @Override
     public Entity getEntity(World world, double x, double y, double z, int metadata, boolean hasVelocity, double xd, double yd, double zd, Entity owner) {
-        FishingBobberEntity bobber = new FishingBobberEntity(world, x, y, z);
+        EntityFishingBobber bobber = new EntityFishingBobber(world, x, y, z);
         if (owner != null) {
             bobber.owner = (Player) owner;
             ((Player) owner).bobberEntity = bobber;
@@ -48,7 +48,7 @@ public class BobberNetEntry implements IVehicleEntry<FishingBobberEntity>, ITrac
     }
 
     @Override
-    public AddEntityPacket getSpawnPacket(EntityTrackerEntry tracker, FishingBobberEntity bobber) {
+    public AddEntityPacket getSpawnPacket(EntityTrackerEntry tracker, EntityFishingBobber bobber) {
         return new AddEntityPacket(bobber, 0, bobber.owner == null ? -1 : bobber.owner.id);
     }
 }
diff --git a/src/main/java/net/minecraft/core/net/entity/entries/CannonballEntry.java b/src/main/java/net/minecraft/core/net/entity/entries/NetEntryCannonball.java
similarity index 74%
rename from src/main/java/net/minecraft/core/net/entity/entries/CannonballEntry.java
rename to src/main/java/net/minecraft/core/net/entity/entries/NetEntryCannonball.java
index 605d42e09..fa46e44e6 100644
--- a/src/main/java/net/minecraft/core/net/entity/entries/CannonballEntry.java
+++ b/src/main/java/net/minecraft/core/net/entity/entries/NetEntryCannonball.java
@@ -2,7 +2,7 @@ package net.minecraft.core.net.entity.entries;
 
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.entity.Mob;
-import net.minecraft.core.entity.projectile.CannonballProjectile;
+import net.minecraft.core.entity.projectile.ProjectileCannonball;
 import net.minecraft.core.net.entity.ITrackedEntry;
 import net.minecraft.core.net.entity.IVehicleEntry;
 import net.minecraft.core.net.packet.AddEntityPacket;
@@ -11,10 +11,10 @@ import net.minecraft.server.entity.EntityTracker;
 import net.minecraft.server.entity.EntityTrackerEntry;
 import org.jetbrains.annotations.NotNull;
 
-public class CannonballEntry implements IVehicleEntry<CannonballProjectile>, ITrackedEntry<CannonballProjectile> {
+public class NetEntryCannonball implements IVehicleEntry<ProjectileCannonball>, ITrackedEntry<ProjectileCannonball> {
     @Override
-    public @NotNull Class<CannonballProjectile> getAppliedClass() {
-        return CannonballProjectile.class;
+    public @NotNull Class<ProjectileCannonball> getAppliedClass() {
+        return ProjectileCannonball.class;
     }
 
     @Override
@@ -33,17 +33,17 @@ public class CannonballEntry implements IVehicleEntry<CannonballProjectile>, ITr
     }
 
     @Override
-    public void onEntityTracked(EntityTracker tracker, EntityTrackerEntry trackerEntry, CannonballProjectile trackedObject) {
+    public void onEntityTracked(EntityTracker tracker, EntityTrackerEntry trackerEntry, ProjectileCannonball trackedObject) {
 
     }
 
     @Override
     public Entity getEntity(World world, double x, double y, double z, int metadata, boolean hasVelocity, double xd, double yd, double zd, Entity owner) {
-        return new CannonballProjectile(world, x, y, z);
+        return new ProjectileCannonball(world, x, y, z);
     }
 
     @Override
-    public AddEntityPacket getSpawnPacket(EntityTrackerEntry tracker, CannonballProjectile trackedObject) {
+    public AddEntityPacket getSpawnPacket(EntityTrackerEntry tracker, ProjectileCannonball trackedObject) {
         Mob entityliving = trackedObject.owner;
         return new AddEntityPacket(trackedObject, -1,
             entityliving == null ? -1 : entityliving.id,
diff --git a/src/main/java/net/minecraft/core/net/entity/entries/EggNetEntry.java b/src/main/java/net/minecraft/core/net/entity/entries/NetEntryEgg.java
similarity index 73%
rename from src/main/java/net/minecraft/core/net/entity/entries/EggNetEntry.java
rename to src/main/java/net/minecraft/core/net/entity/entries/NetEntryEgg.java
index ada44ecc5..27a5459b9 100644
--- a/src/main/java/net/minecraft/core/net/entity/entries/EggNetEntry.java
+++ b/src/main/java/net/minecraft/core/net/entity/entries/NetEntryEgg.java
@@ -1,7 +1,7 @@
 package net.minecraft.core.net.entity.entries;
 
 import net.minecraft.core.entity.Entity;
-import net.minecraft.core.entity.projectile.EggProjectile;
+import net.minecraft.core.entity.projectile.ProjectileEgg;
 import net.minecraft.core.net.entity.ITrackedEntry;
 import net.minecraft.core.net.entity.IVehicleEntry;
 import net.minecraft.core.net.packet.AddEntityPacket;
@@ -10,10 +10,10 @@ import net.minecraft.server.entity.EntityTracker;
 import net.minecraft.server.entity.EntityTrackerEntry;
 import org.jetbrains.annotations.NotNull;
 
-public class EggNetEntry implements IVehicleEntry<EggProjectile>, ITrackedEntry<EggProjectile> {
+public class NetEntryEgg implements IVehicleEntry<ProjectileEgg>, ITrackedEntry<ProjectileEgg> {
     @Override
-    public @NotNull Class<EggProjectile> getAppliedClass() {
-        return EggProjectile.class;
+    public @NotNull Class<ProjectileEgg> getAppliedClass() {
+        return ProjectileEgg.class;
     }
 
     @Override
@@ -32,17 +32,17 @@ public class EggNetEntry implements IVehicleEntry<EggProjectile>, ITrackedEntry<
     }
 
     @Override
-    public void onEntityTracked(EntityTracker tracker, EntityTrackerEntry trackerEntry, EggProjectile trackedObject) {
+    public void onEntityTracked(EntityTracker tracker, EntityTrackerEntry trackerEntry, ProjectileEgg trackedObject) {
 
     }
 
     @Override
     public Entity getEntity(World world, double x, double y, double z, int metadata, boolean hasVelocity, double xd, double yd, double zd, Entity owner) {
-        return new EggProjectile(world, x, y, z);
+        return new ProjectileEgg(world, x, y, z);
     }
 
     @Override
-    public AddEntityPacket getSpawnPacket(EntityTrackerEntry tracker, EggProjectile trackedObject) {
+    public AddEntityPacket getSpawnPacket(EntityTrackerEntry tracker, ProjectileEgg trackedObject) {
         return new AddEntityPacket(trackedObject);
     }
 }
diff --git a/src/main/java/net/minecraft/core/net/entity/entries/FallingSandNetEntry.java b/src/main/java/net/minecraft/core/net/entity/entries/NetEntryFallingBlock.java
similarity index 74%
rename from src/main/java/net/minecraft/core/net/entity/entries/FallingSandNetEntry.java
rename to src/main/java/net/minecraft/core/net/entity/entries/NetEntryFallingBlock.java
index 907a78e46..c6daabc21 100644
--- a/src/main/java/net/minecraft/core/net/entity/entries/FallingSandNetEntry.java
+++ b/src/main/java/net/minecraft/core/net/entity/entries/NetEntryFallingBlock.java
@@ -2,7 +2,7 @@ package net.minecraft.core.net.entity.entries;
 
 import net.minecraft.core.block.Block;
 import net.minecraft.core.entity.Entity;
-import net.minecraft.core.entity.FallingBlockEntity;
+import net.minecraft.core.entity.EntityFallingBlock;
 import net.minecraft.core.net.entity.ITrackedEntry;
 import net.minecraft.core.net.entity.IVehicleEntry;
 import net.minecraft.core.net.packet.AddEntityPacket;
@@ -12,10 +12,10 @@ import net.minecraft.server.entity.EntityTracker;
 import net.minecraft.server.entity.EntityTrackerEntry;
 import org.jetbrains.annotations.NotNull;
 
-public class FallingSandNetEntry implements IVehicleEntry<FallingBlockEntity>, ITrackedEntry<FallingBlockEntity> {
+public class NetEntryFallingBlock implements IVehicleEntry<EntityFallingBlock>, ITrackedEntry<EntityFallingBlock> {
     @Override
-    public @NotNull Class<FallingBlockEntity> getAppliedClass() {
-        return FallingBlockEntity.class;
+    public @NotNull Class<EntityFallingBlock> getAppliedClass() {
+        return EntityFallingBlock.class;
     }
 
     @Override
@@ -34,17 +34,17 @@ public class FallingSandNetEntry implements IVehicleEntry<FallingBlockEntity>, I
     }
 
     @Override
-    public void onEntityTracked(EntityTracker tracker, EntityTrackerEntry trackerEntry, FallingBlockEntity trackedObject) {
+    public void onEntityTracked(EntityTracker tracker, EntityTrackerEntry trackerEntry, EntityFallingBlock trackedObject) {
 
     }
 
     @Override
     public Entity getEntity(World world, double x, double y, double z, int metadata, boolean hasVelocity, double xd, double yd, double zd, Entity owner) {
-        return new FallingBlockEntity(world, x, y, z, MathHelper.clamp(metadata, 0, Block.blocksList.length), 0, null);
+        return new EntityFallingBlock(world, x, y, z, MathHelper.clamp(metadata, 0, Block.blocksList.length), 0, null);
     }
 
     @Override
-    public AddEntityPacket getSpawnPacket(EntityTrackerEntry tracker, FallingBlockEntity trackedObject) {
+    public AddEntityPacket getSpawnPacket(EntityTrackerEntry tracker, EntityFallingBlock trackedObject) {
         return new AddEntityPacket(trackedObject, trackedObject.carriedBlock.blockId);
     }
 }
diff --git a/src/main/java/net/minecraft/core/net/entity/entries/FireballNetEntry.java b/src/main/java/net/minecraft/core/net/entity/entries/NetEntryFireball.java
similarity index 72%
rename from src/main/java/net/minecraft/core/net/entity/entries/FireballNetEntry.java
rename to src/main/java/net/minecraft/core/net/entity/entries/NetEntryFireball.java
index e1b905560..990bd5f29 100644
--- a/src/main/java/net/minecraft/core/net/entity/entries/FireballNetEntry.java
+++ b/src/main/java/net/minecraft/core/net/entity/entries/NetEntryFireball.java
@@ -1,7 +1,7 @@
 package net.minecraft.core.net.entity.entries;
 
 import net.minecraft.core.entity.Entity;
-import net.minecraft.core.entity.projectile.FireballProjectile;
+import net.minecraft.core.entity.projectile.ProjectileFireball;
 import net.minecraft.core.net.entity.ITrackedEntry;
 import net.minecraft.core.net.entity.IVehicleEntry;
 import net.minecraft.core.net.packet.AddEntityPacket;
@@ -10,10 +10,10 @@ import net.minecraft.server.entity.EntityTracker;
 import net.minecraft.server.entity.EntityTrackerEntry;
 import org.jetbrains.annotations.NotNull;
 
-public class FireballNetEntry implements IVehicleEntry<FireballProjectile>, ITrackedEntry<FireballProjectile> {
+public class NetEntryFireball implements IVehicleEntry<ProjectileFireball>, ITrackedEntry<ProjectileFireball> {
     @Override
-    public @NotNull Class<FireballProjectile> getAppliedClass() {
-        return FireballProjectile.class;
+    public @NotNull Class<ProjectileFireball> getAppliedClass() {
+        return ProjectileFireball.class;
     }
 
     @Override
@@ -32,17 +32,17 @@ public class FireballNetEntry implements IVehicleEntry<FireballProjectile>, ITra
     }
 
     @Override
-    public void onEntityTracked(EntityTracker tracker, EntityTrackerEntry trackerEntry, FireballProjectile trackedObject) {
+    public void onEntityTracked(EntityTracker tracker, EntityTrackerEntry trackerEntry, ProjectileFireball trackedObject) {
 
     }
 
     @Override
     public Entity getEntity(World world, double x, double y, double z, int metadata, boolean hasVelocity, double xd, double yd, double zd, Entity owner) {
-        return new FireballProjectile(world, x, y, z, xd, yd, zd);
+        return new ProjectileFireball(world, x, y, z, xd, yd, zd);
     }
 
     @Override
-    public AddEntityPacket getSpawnPacket(EntityTrackerEntry tracker, FireballProjectile trackedObject) {
+    public AddEntityPacket getSpawnPacket(EntityTrackerEntry tracker, ProjectileFireball trackedObject) {
         return new AddEntityPacket(trackedObject, -1, -1, trackedObject.xd, trackedObject.yd, trackedObject.zd);
     }
 }
diff --git a/src/main/java/net/minecraft/core/net/entity/entries/NetEntryFirefly.java b/src/main/java/net/minecraft/core/net/entity/entries/NetEntryFirefly.java
new file mode 100644
index 000000000..d1b3a5420
--- /dev/null
+++ b/src/main/java/net/minecraft/core/net/entity/entries/NetEntryFirefly.java
@@ -0,0 +1,15 @@
+package net.minecraft.core.net.entity.entries;
+
+import net.minecraft.core.entity.animal.MobFireflyCluster;
+import org.jetbrains.annotations.NotNull;
+
+public class NetEntryFirefly extends NetEntryAnimal<MobFireflyCluster> {
+    @Override
+    public @NotNull Class<MobFireflyCluster> getAppliedClass() {
+        return MobFireflyCluster.class;
+    }
+    @Override
+    public int getPacketDelay() {
+        return 40;
+    }
+}
diff --git a/src/main/java/net/minecraft/core/net/entity/entries/ItemNetEntry.java b/src/main/java/net/minecraft/core/net/entity/entries/NetEntryItem.java
similarity index 75%
rename from src/main/java/net/minecraft/core/net/entity/entries/ItemNetEntry.java
rename to src/main/java/net/minecraft/core/net/entity/entries/NetEntryItem.java
index 5932262a1..3ad04539e 100644
--- a/src/main/java/net/minecraft/core/net/entity/entries/ItemNetEntry.java
+++ b/src/main/java/net/minecraft/core/net/entity/entries/NetEntryItem.java
@@ -1,6 +1,6 @@
 package net.minecraft.core.net.entity.entries;
 
-import net.minecraft.core.entity.ItemEntity;
+import net.minecraft.core.entity.EntityItem;
 import net.minecraft.core.net.entity.IPacketEntry;
 import net.minecraft.core.net.entity.ITrackedEntry;
 import net.minecraft.core.net.packet.Packet;
@@ -9,10 +9,10 @@ import net.minecraft.server.entity.EntityTracker;
 import net.minecraft.server.entity.EntityTrackerEntry;
 import org.jetbrains.annotations.NotNull;
 
-public class ItemNetEntry implements IPacketEntry<ItemEntity>, ITrackedEntry<ItemEntity> {
+public class NetEntryItem implements IPacketEntry<EntityItem>, ITrackedEntry<EntityItem> {
     @Override
-    public @NotNull Class<ItemEntity> getAppliedClass() {
-        return ItemEntity.class;
+    public @NotNull Class<EntityItem> getAppliedClass() {
+        return EntityItem.class;
     }
 
     @Override
@@ -31,12 +31,12 @@ public class ItemNetEntry implements IPacketEntry<ItemEntity>, ITrackedEntry<Ite
     }
 
     @Override
-    public void onEntityTracked(EntityTracker tracker, EntityTrackerEntry trackerEntry, ItemEntity trackedObject) {
+    public void onEntityTracked(EntityTracker tracker, EntityTrackerEntry trackerEntry, EntityItem trackedObject) {
 
     }
 
     @Override
-    public Packet getSpawnPacket(EntityTrackerEntry tracker, ItemEntity trackedObject) {
+    public Packet getSpawnPacket(EntityTrackerEntry tracker, EntityItem trackedObject) {
         AddItemEntityPacket addItemEntityPacket21Pickupspawn = new AddItemEntityPacket(trackedObject);
         trackedObject.x = addItemEntityPacket21Pickupspawn.xPosition / 32D;
         trackedObject.y = addItemEntityPacket21Pickupspawn.yPosition / 32D;
diff --git a/src/main/java/net/minecraft/core/net/entity/entries/MinecartNetEntry.java b/src/main/java/net/minecraft/core/net/entity/entries/NetEntryMinecart.java
similarity index 95%
rename from src/main/java/net/minecraft/core/net/entity/entries/MinecartNetEntry.java
rename to src/main/java/net/minecraft/core/net/entity/entries/NetEntryMinecart.java
index 32ed74a76..a0039d333 100644
--- a/src/main/java/net/minecraft/core/net/entity/entries/MinecartNetEntry.java
+++ b/src/main/java/net/minecraft/core/net/entity/entries/NetEntryMinecart.java
@@ -10,7 +10,7 @@ import net.minecraft.server.entity.EntityTracker;
 import net.minecraft.server.entity.EntityTrackerEntry;
 import org.jetbrains.annotations.NotNull;
 
-public class MinecartNetEntry implements IVehicleEntry<MinecartEntity>, ITrackedEntry<MinecartEntity> {
+public class NetEntryMinecart implements IVehicleEntry<MinecartEntity>, ITrackedEntry<MinecartEntity> {
     @Override
     public @NotNull Class<MinecartEntity> getAppliedClass() {
         return MinecartEntity.class;
diff --git a/src/main/java/net/minecraft/core/net/entity/entries/PaintingNetEntry.java b/src/main/java/net/minecraft/core/net/entity/entries/NetEntryPainting.java
similarity index 67%
rename from src/main/java/net/minecraft/core/net/entity/entries/PaintingNetEntry.java
rename to src/main/java/net/minecraft/core/net/entity/entries/NetEntryPainting.java
index cfbced100..20eb2ecc4 100644
--- a/src/main/java/net/minecraft/core/net/entity/entries/PaintingNetEntry.java
+++ b/src/main/java/net/minecraft/core/net/entity/entries/NetEntryPainting.java
@@ -1,6 +1,6 @@
 package net.minecraft.core.net.entity.entries;
 
-import net.minecraft.core.entity.PaintingEntity;
+import net.minecraft.core.entity.EntityPainting;
 import net.minecraft.core.net.entity.IPacketEntry;
 import net.minecraft.core.net.entity.ITrackedEntry;
 import net.minecraft.core.net.packet.Packet;
@@ -9,10 +9,10 @@ import net.minecraft.server.entity.EntityTracker;
 import net.minecraft.server.entity.EntityTrackerEntry;
 import org.jetbrains.annotations.NotNull;
 
-public class PaintingNetEntry implements IPacketEntry<PaintingEntity>, ITrackedEntry<PaintingEntity> {
+public class NetEntryPainting implements IPacketEntry<EntityPainting>, ITrackedEntry<EntityPainting> {
     @Override
-    public @NotNull Class<PaintingEntity> getAppliedClass() {
-        return PaintingEntity.class;
+    public @NotNull Class<EntityPainting> getAppliedClass() {
+        return EntityPainting.class;
     }
 
     @Override
@@ -31,12 +31,12 @@ public class PaintingNetEntry implements IPacketEntry<PaintingEntity>, ITrackedE
     }
 
     @Override
-    public void onEntityTracked(EntityTracker tracker, EntityTrackerEntry trackerEntry, PaintingEntity trackedObject) {
+    public void onEntityTracked(EntityTracker tracker, EntityTrackerEntry trackerEntry, EntityPainting trackedObject) {
 
     }
 
     @Override
-    public Packet getSpawnPacket(EntityTrackerEntry tracker, PaintingEntity trackedObject) {
+    public Packet getSpawnPacket(EntityTrackerEntry tracker, EntityPainting trackedObject) {
         return new AddPaintingPacket(trackedObject);
     }
 }
